
import sys
import argparse
parser = argparse.ArgumentParser(
    description="RPC Reinforcement Learning Example",
    formatter_class=argparse.ArgumentDefaultsHelpFormatter,
)
parser.add_argument('--world_size', default=2, type=int, metavar='W',
                    help='number of workers')
parser.add_argument('--rank', default=0, type=int, metavar='W',
                    help='rank of the worker')
parser.add_argument('--log_interval', type=int, default=10, metavar='N',
                    help='interval between training status logs')
parser.add_argument('--gamma', type=float, default=0.99, metavar='G',
                    help='how much to value future rewards')
parser.add_argument('--seed', type=int, default=1, metavar='S',
                    help='random seed  for reproducibility')
parser.add_argument('--num_sampler', type=int, default=4, metavar='S',
                    help='number of samplers')
parser.add_argument('--queue_size', type=int, default=40, metavar='S',
                    help='sampler queue size')
args = parser.parse_args()
rpc_proxy=None
WORKER_RANK = args.rank
NUM_SAMPLER = args.num_sampler
WORLD_SIZE = args.world_size
QUEUE_SIZE = args.queue_size
MAX_QUEUE_SIZE = 5*args.queue_size
RPC_NAME = "rpcserver{}"
def _get_worker_rank():
    return WORKER_RANK
def _get_num_sampler():
    return NUM_SAMPLER
def _get_world_size():
    return WORLD_SIZE
def _get_RPC_NAME():
    return RPC_NAME
def _get_queue_size():
    return QUEUE_SIZE
def _get_max_queue_size():
    return MAX_QUEUE_SIZE
def _get_rpc_name():
    return RPC_NAME